#include<pthread.h>
#include<signal.h>
#include<memory.h>
#include<setjmp.h>

#define _try \
	{ \
	 sigjmp_buf _1,*_0=(sigjmp_buf*)pthread_getspecific(jmp_key);	\
	pthread_setspecific(jmp_key,&_1); \
	if(!sigsetjmp(_1,1)) 
#define _catch else
#define _final pthread_setspecific(jmp_key,*_0); }

#define _try_safe {static bool ok=true; if(ok) _try
#define _catch_safe else { ok=false;
#define _final_safe _final }}



pthread_key_t jmp_key;


void hand(int sig)
{
	sigjmp_buf *ref=(sigjmp_buf*)pthread_getspecific(jmp_key);
	if(ref) siglongjmp(*ref,1);
} 


inline void TryInit() 
{
	struct sigaction act;
	memset(&act,0,sizeof(act));
	act.sa_handler=hand;
	sigaction(SIGFPE,&act,0); 
	sigaction(SIGSEGV,&act,0); 
	pthread_key_create(&jmp_key,0);	// ñîçäà¸ì êëþ÷ äëÿ ëîêàëüíûõ äàííûõ ïîòîêà
}


